SDL2_gfx: I:/Sources/sdl2gfx/SDL2_gfxPrimitives.c File Reference

SDL2_gfx 1.0.0 GraphicsprimitivesandsurfacefunctionsforSDL2

- Main Page
- Data Structures
- Files

- File List
- Globals

Data Structures | Defines | Functions
I:/Sources/sdl2gfx/SDL2_gfxPrimitives.c File Reference
`#include <stdio.h>`
`#include <stdlib.h>`
`#include <math.h>`
`#include <string.h>`
`#include "SDL2_gfxPrimitives.h"`
`#include "SDL2_rotozoom.h"`
`#include "SDL2_gfxPrimitives_font.h"`

Go to the source code of this file.

## Data Structures
struct | SDL2_gfxBresenhamIterator
| The structure passed to the internal Bresenham iterator. More...
struct | SDL2_gfxMurphyIterator
| The structure passed to the internal Murphy iterator. More...
## Defines
#define | AAlevels 256
#define | AAbits 8
#define | HYPOT(x, y) sqrt((double)(x)*(double)(x)+(double)(y)*(double)(y))
## Functions
int | pixel (SDL_Renderer *renderer, Sint16 x, Sint16 y)
| Draw pixel in currently set color.
int | pixelColor (SDL_Renderer *renderer, Sint16 x, Sint16 y, Uint32 color)
| Draw pixel with blending enabled if a<255.
int | pixelRGBA (SDL_Renderer *renderer, Sint16 x, Sint16 y, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw pixel with blending enabled if a<255.
int | pixelRGBAWeight (SDL_Renderer *renderer, Sint16 x, Sint16 y, Uint8 r, Uint8 g, Uint8 b, Uint8 a, Uint32 weight)
| Draw pixel with blending enabled and using alpha weight on color.
int | hline (SDL_Renderer *renderer, Sint16 x1, Sint16 x2, Sint16 y)
| Draw horizontal line in currently set color.
int | hlineColor (SDL_Renderer *renderer, Sint16 x1, Sint16 x2, Sint16 y, Uint32 color)
| Draw horizontal line with blending.
int | hlineRGBA (SDL_Renderer *renderer, Sint16 x1, Sint16 x2, Sint16 y, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw horizontal line with blending.
int | vlineColor (SDL_Renderer *renderer, Sint16 x, Sint16 y1, Sint16 y2, Uint32 color)
| Draw vertical line with blending.
int | vlineRGBA (SDL_Renderer *renderer, Sint16 x, Sint16 y1, Sint16 y2, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw vertical line with blending.
int | rectangleColor (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Uint32 color)
| Draw rectangle with blending.
int | rectangleRGBA (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw rectangle with blending.
int | roundedRectangleColor (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Sint16 rad, Uint32 color)
| Draw rounded-corner rectangle with blending.
int | roundedRectangleRGBA (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Sint16 rad, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw rounded-corner rectangle with blending.
int | roundedBoxColor (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Sint16 rad, Uint32 color)
| Draw rounded-corner box (filled rectangle) with blending.
int | roundedBoxRGBA (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Sint16 rad, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw rounded-corner box (filled rectangle) with blending.
int | boxColor (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Uint32 color)
| Draw box (filled rectangle) with blending.
int | boxRGBA (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw box (filled rectangle) with blending.
int | line (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2)
| Draw line with alpha blending using the currently set color.
int | lineColor (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Uint32 color)
| Draw line with alpha blending.
int | lineRGBA (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw line with alpha blending.
int | _aalineRGBA (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Uint8 r, Uint8 g, Uint8 b, Uint8 a, int draw_endpoint)
| Internal function to draw anti-aliased line with alpha blending and endpoint control.
int | aalineColor (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Uint32 color)
| Draw anti-aliased line with alpha blending.
int | aalineRGBA (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw anti-aliased line with alpha blending.
int | circleColor (SDL_Renderer *renderer, Sint16 x, Sint16 y, Sint16 rad, Uint32 color)
| Draw circle with blending.
int | circleRGBA (SDL_Renderer *renderer, Sint16 x, Sint16 y, Sint16 rad, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw circle with blending.
int | arcColor (SDL_Renderer *renderer, Sint16 x, Sint16 y, Sint16 rad, Sint16 start, Sint16 end, Uint32 color)
| Arc with blending.
int | arcRGBA (SDL_Renderer *renderer, Sint16 x, Sint16 y, Sint16 rad, Sint16 start, Sint16 end, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Arc with blending.
int | aacircleColor (SDL_Renderer *renderer, Sint16 x, Sint16 y, Sint16 rad, Uint32 color)
| Draw anti-aliased circle with blending.
int | aacircleRGBA (SDL_Renderer *renderer, Sint16 x, Sint16 y, Sint16 rad, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw anti-aliased circle with blending.
int | filledCircleColor (SDL_Renderer *renderer, Sint16 x, Sint16 y, Sint16 rad, Uint32 color)
| Draw filled circle with blending.
int | filledCircleRGBA (SDL_Renderer *renderer, Sint16 x, Sint16 y, Sint16 rad, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw filled circle with blending.
int | ellipseColor (SDL_Renderer *renderer, Sint16 x, Sint16 y, Sint16 rx, Sint16 ry, Uint32 color)
| Draw ellipse with blending.
int | ellipseRGBA (SDL_Renderer *renderer, Sint16 x, Sint16 y, Sint16 rx, Sint16 ry, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw ellipse with blending.
int | aaellipseColor (SDL_Renderer *renderer, Sint16 x, Sint16 y, Sint16 rx, Sint16 ry, Uint32 color)
| Draw anti-aliased ellipse with blending.
int | aaellipseRGBA (SDL_Renderer *renderer, Sint16 x, Sint16 y, Sint16 rx, Sint16 ry, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw anti-aliased ellipse with blending.
int | filledEllipseColor (SDL_Renderer *renderer, Sint16 x, Sint16 y, Sint16 rx, Sint16 ry, Uint32 color)
| Draw filled ellipse with blending.
int | filledEllipseRGBA (SDL_Renderer *renderer, Sint16 x, Sint16 y, Sint16 rx, Sint16 ry, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw filled ellipse with blending.
int | _pieRGBA (SDL_Renderer *renderer, Sint16 x, Sint16 y, Sint16 rad, Sint16 start, Sint16 end, Uint8 r, Uint8 g, Uint8 b, Uint8 a, Uint8 filled)
| Internal float (low-speed) pie-calc implementation by drawing polygons.
int | pieColor (SDL_Renderer *renderer, Sint16 x, Sint16 y, Sint16 rad, Sint16 start, Sint16 end, Uint32 color)
| Draw pie (outline) with alpha blending.
int | pieRGBA (SDL_Renderer *renderer, Sint16 x, Sint16 y, Sint16 rad, Sint16 start, Sint16 end, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw pie (outline) with alpha blending.
int | filledPieColor (SDL_Renderer *renderer, Sint16 x, Sint16 y, Sint16 rad, Sint16 start, Sint16 end, Uint32 color)
| Draw filled pie with alpha blending.
int | filledPieRGBA (SDL_Renderer *renderer, Sint16 x, Sint16 y, Sint16 rad, Sint16 start, Sint16 end, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw filled pie with alpha blending.
int | trigonColor (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Sint16 x3, Sint16 y3, Uint32 color)
| Draw trigon (triangle outline) with alpha blending.
int | trigonRGBA (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Sint16 x3, Sint16 y3, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw trigon (triangle outline) with alpha blending.
int | aatrigonColor (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Sint16 x3, Sint16 y3, Uint32 color)
| Draw anti-aliased trigon (triangle outline) with alpha blending.
int | aatrigonRGBA (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Sint16 x3, Sint16 y3, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw anti-aliased trigon (triangle outline) with alpha blending.
int | filledTrigonColor (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Sint16 x3, Sint16 y3, Uint32 color)
| Draw filled trigon (triangle) with alpha blending.
int | filledTrigonRGBA (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Sint16 x3, Sint16 y3, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw filled trigon (triangle) with alpha blending.
int | polygonColor (SDL_Renderer *renderer, const Sint16 *vx, const Sint16 *vy, int n, Uint32 color)
| Draw polygon with alpha blending.
int | polygon (SDL_Renderer *renderer, const Sint16 *vx, const Sint16 *vy, int n)
| Draw polygon with the currently set color and blend mode.
int | polygonRGBA (SDL_Renderer *renderer, const Sint16 *vx, const Sint16 *vy, int n, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw polygon with alpha blending.
int | aapolygonColor (SDL_Renderer *renderer, const Sint16 *vx, const Sint16 *vy, int n, Uint32 color)
| Draw anti-aliased polygon with alpha blending.
int | aapolygonRGBA (SDL_Renderer *renderer, const Sint16 *vx, const Sint16 *vy, int n, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw anti-aliased polygon with alpha blending.
int | _gfxPrimitivesCompareInt (const void *a, const void *b)
| Internal helper qsort callback functions used in filled polygon drawing.
int | filledPolygonRGBAMT (SDL_Renderer *renderer, const Sint16 *vx, const Sint16 *vy, int n, Uint8 r, Uint8 g, Uint8 b, Uint8 a, int **polyInts, int *polyAllocated)
| Draw filled polygon with alpha blending (multi-threaded capable).
int | filledPolygonColor (SDL_Renderer *renderer, const Sint16 *vx, const Sint16 *vy, int n, Uint32 color)
| Draw filled polygon with alpha blending.
int | filledPolygonRGBA (SDL_Renderer *renderer, const Sint16 *vx, const Sint16 *vy, int n, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw filled polygon with alpha blending.
int | _HLineTextured (SDL_Renderer *renderer, Sint16 x1, Sint16 x2, Sint16 y, SDL_Texture *texture, int texture_w, int texture_h, int texture_dx, int texture_dy)
| Internal function to draw a textured horizontal line.
int | texturedPolygonMT (SDL_Renderer *renderer, const Sint16 *vx, const Sint16 *vy, int n, SDL_Surface *texture, int texture_dx, int texture_dy, int **polyInts, int *polyAllocated)
| Draws a polygon filled with the given texture (Multi-Threading Capable).
int | texturedPolygon (SDL_Renderer *renderer, const Sint16 *vx, const Sint16 *vy, int n, SDL_Surface *texture, int texture_dx, int texture_dy)
| Draws a polygon filled with the given texture.
void | gfxPrimitivesSetFont (const void *fontdata, Uint32 cw, Uint32 ch)
| Sets or resets the current global font data.
void | gfxPrimitivesSetFontRotation (Uint32 rotation)
| Sets current global font character rotation steps.
int | characterRGBA (SDL_Renderer *renderer, Sint16 x, Sint16 y, char c, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw a character of the currently set font.
int | characterColor (SDL_Renderer *renderer, Sint16 x, Sint16 y, char c, Uint32 color)
| Draw a character of the currently set font.
int | stringColor (SDL_Renderer *renderer, Sint16 x, Sint16 y, const char *s, Uint32 color)
| Draw a string in the currently set font.
int | stringRGBA (SDL_Renderer *renderer, Sint16 x, Sint16 y, const char *s, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw a string in the currently set font.
double | _evaluateBezier (double *data, int ndata, double t)
| Internal function to calculate bezier interpolator of data array with ndata values at position 't'.
int | bezierColor (SDL_Renderer *renderer, const Sint16 *vx, const Sint16 *vy, int n, int s, Uint32 color)
| Draw a bezier curve with alpha blending.
int | bezierRGBA (SDL_Renderer *renderer, const Sint16 *vx, const Sint16 *vy, int n, int s, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw a bezier curve with alpha blending.
int | _bresenhamInitialize (SDL2_gfxBresenhamIterator *b, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2)
| Internal function to initialize the Bresenham line iterator.
int | _bresenhamIterate (SDL2_gfxBresenhamIterator *b)
| Internal function to move Bresenham line iterator to the next position.
void | _murphyParaline (SDL2_gfxMurphyIterator *m, Sint16 x, Sint16 y, int d1)
| Internal function to to draw parallel lines with Murphy algorithm.
void | _murphyIteration (SDL2_gfxMurphyIterator *m, Uint8 miter, Uint16 ml1bx, Uint16 ml1by, Uint16 ml2bx, Uint16 ml2by, Uint16 ml1x, Uint16 ml1y, Uint16 ml2x, Uint16 ml2y)
| Internal function to to draw one iteration of the Murphy algorithm.
void | _murphyWideline (SDL2_gfxMurphyIterator *m, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Uint8 width, Uint8 miter)
| Internal function to to draw wide lines with Murphy algorithm.
int | thickLineColor (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Uint8 width, Uint32 color)
| Draw a thick line with alpha blending.
int | thickLineRGBA (SDL_Renderer *renderer, Sint16 x1, Sint16 y1, Sint16 x2, Sint16 y2, Uint8 width, Uint8 r, Uint8 g, Uint8 b, Uint8 a)
| Draw a thick line with alpha blending.

## Define Documentation

#define AAbits 8

Definition at line 791 of file SDL2_gfxPrimitives.c.

#define AAlevels 256

Definition at line 790 of file SDL2_gfxPrimitives.c.

#define HYPOT | ( |  | x,
|  |  | y
| ) |  | sqrt((double)(x)*(double)(x)+(double)(y)*(double)(y))

Definition at line 4037 of file SDL2_gfxPrimitives.c.

## Function Documentation

int _aalineRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a,
|  | int | draw_endpoint
| ) |  |

Internal function to draw anti-aliased line with alpha blending and endpoint control.

This implementation of the Wu antialiasing code is based on Mike Abrash's DDJ article which was reprinted as Chapter 42 of his Graphics Programming Black Book, but has been optimized to work with SDL and utilizes 32-bit fixed-point arithmetic by A. Schiffler. The endpoint control allows the supression to draw the last pixel useful for rendering continous aa-lines with alpha<255.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point of the aa-line.
  y1 | Y coordinate of the first point of the aa-line.
  x2 | X coordinate of the second point of the aa-line.
  y2 | Y coordinate of the second point of the aa-line.
  r | The red value of the aa-line to draw.
  g | The green value of the aa-line to draw.
  b | The blue value of the aa-line to draw.
  a | The alpha value of the aa-line to draw.
  draw_endpoint | Flag indicating if the endpoint should be drawn; draw if non-zero.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 816 of file SDL2_gfxPrimitives.c.

int _bresenhamInitialize | ( | SDL2_gfxBresenhamIterator * | b,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2
| ) |  |

Internal function to initialize the Bresenham line iterator.

Example of use: SDL2_gfxBresenhamIterator b; _bresenhamInitialize (&b, x1, y1, x2, y2); do { plot(b.x, b.y); } while (_bresenhamIterate(&b)==0);

Parameters:

  b | Pointer to struct for bresenham line drawing state.
  x1 | X coordinate of the first point of the line.
  y1 | Y coordinate of the first point of the line.
  x2 | X coordinate of the second point of the line.
  y2 | Y coordinate of the second point of the line.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 3775 of file SDL2_gfxPrimitives.c.

int _bresenhamIterate | ( | SDL2_gfxBresenhamIterator * | b | ) |

Internal function to move Bresenham line iterator to the next position.

Maybe updates the x and y coordinates of the iterator struct.

Parameters:

  b | Pointer to struct for bresenham line drawing state.

Returns:
  Returns 0 on success, 1 if last point was reached, 2 if moving past end-of-line, -1 on failure.

Definition at line 3837 of file SDL2_gfxPrimitives.c.

double _evaluateBezier | ( | double * | data,
|  | int | ndata,
|  | double | t
| ) |  |

Internal function to calculate bezier interpolator of data array with ndata values at position 't'.

Parameters:

  data | Array of values.
  ndata | Size of array.
  t | Position for which to calculate interpolated value. t should be between [0, ndata].

Returns:
  Interpolated value at position t, value[0] when t<0, value[n-1] when t>n.

Definition at line 3608 of file SDL2_gfxPrimitives.c.

int _gfxPrimitivesCompareInt | ( | const void * | a,
|  | const void * | b
| ) |  |

Internal helper qsort callback functions used in filled polygon drawing.

Parameters:

  a | The surface to draw on.
  b | Vertex array containing X coordinates of the points of the polygon.

Returns:
  Returns 0 if a==b, a negative number if a<b or a positive number if a>b.

Definition at line 2741 of file SDL2_gfxPrimitives.c.

int _HLineTextured | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | x2,
|  | Sint16 | y,
|  | SDL_Texture * | texture,
|  | int | texture_w,
|  | int | texture_h,
|  | int | texture_dx,
|  | int | texture_dy
| ) |  |

Internal function to draw a textured horizontal line.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point (i.e. left) of the line.
  x2 | X coordinate of the second point (i.e. right) of the line.
  y | Y coordinate of the points of the line.
  texture | The texture to retrieve color information from.
  texture_w | The width of the texture.
  texture_h | The height of the texture.
  texture_dx | The X offset for the texture lookup.
  texture_dy | The Y offset for the textured lookup.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 2988 of file SDL2_gfxPrimitives.c.

void _murphyIteration | ( | SDL2_gfxMurphyIterator * | m,
|  | Uint8 | miter,
|  | Uint16 | ml1bx,
|  | Uint16 | ml1by,
|  | Uint16 | ml2bx,
|  | Uint16 | ml2by,
|  | Uint16 | ml1x,
|  | Uint16 | ml1y,
|  | Uint16 | ml2x,
|  | Uint16 | ml2y
| ) |  |

Internal function to to draw one iteration of the Murphy algorithm.

Parameters:

  m | Pointer to struct for murphy iterator.
  miter | Iteration count.
  ml1bx | X coordinate of a point.
  ml1by | Y coordinate of a point.
  ml2bx | X coordinate of a point.
  ml2by | Y coordinate of a point.
  ml1x | X coordinate of a point.
  ml1y | Y coordinate of a point.
  ml2x | X coordinate of a point.
  ml2y | Y coordinate of a point.

Definition at line 3930 of file SDL2_gfxPrimitives.c.

void _murphyParaline | ( | SDL2_gfxMurphyIterator * | m,
|  | Sint16 | x,
|  | Sint16 | y,
|  | int | d1
| ) |  |

Internal function to to draw parallel lines with Murphy algorithm.

Parameters:

  m | Pointer to struct for murphy iterator.
  x | X coordinate of point.
  y | Y coordinate of point.
  d1 | Direction square/diagonal.

Definition at line 3880 of file SDL2_gfxPrimitives.c.

void _murphyWideline | ( | SDL2_gfxMurphyIterator * | m,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Uint8 | width,
|  | Uint8 | miter
| ) |  |

Internal function to to draw wide lines with Murphy algorithm.

Draws lines parallel to ideal line.

Parameters:

  m | Pointer to struct for murphy iterator.
  x1 | X coordinate of first point.
  y1 | Y coordinate of first point.
  x2 | X coordinate of second point.
  y2 | Y coordinate of second point.
  width | Width of line.
  miter | Iteration count.

Definition at line 4053 of file SDL2_gfxPrimitives.c.

int _pieRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Sint16 | rad,
|  | Sint16 | start,
|  | Sint16 | end,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a,
|  | Uint8 | filled
| ) |  |

Internal float (low-speed) pie-calc implementation by drawing polygons.

Note: Determines vertex array and uses polygon or filledPolygon drawing routines to render.

Parameters:

  renderer | The renderer to draw on.
  x | X coordinate of the center of the pie.
  y | Y coordinate of the center of the pie.
  rad | Radius in pixels of the pie.
  start | Starting radius in degrees of the pie.
  end | Ending radius in degrees of the pie.
  r | The red value of the pie to draw.
  g | The green value of the pie to draw.
  b | The blue value of the pie to draw.
  a | The alpha value of the pie to draw.
  filled | Flag indicating if the pie should be filled (=1) or not (=0).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 2122 of file SDL2_gfxPrimitives.c.

int aacircleColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Sint16 | rad,
|  | Uint32 | color
| ) |  |

Draw anti-aliased circle with blending.

Parameters:

  renderer | The renderer to draw on.
  x | X coordinate of the center of the aa-circle.
  y | Y coordinate of the center of the aa-circle.
  rad | Radius in pixels of the aa-circle.
  color | The color value of the aa-circle to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 1364 of file SDL2_gfxPrimitives.c.

int aacircleRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Sint16 | rad,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw anti-aliased circle with blending.

Parameters:

  renderer | The renderer to draw on.
  x | X coordinate of the center of the aa-circle.
  y | Y coordinate of the center of the aa-circle.
  rad | Radius in pixels of the aa-circle.
  r | The red value of the aa-circle to draw.
  g | The green value of the aa-circle to draw.
  b | The blue value of the aa-circle to draw.
  a | The alpha value of the aa-circle to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 1384 of file SDL2_gfxPrimitives.c.

int aaellipseColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Sint16 | rx,
|  | Sint16 | ry,
|  | Uint32 | color
| ) |  |

Draw anti-aliased ellipse with blending.

Parameters:

  renderer | The renderer to draw on.
  x | X coordinate of the center of the aa-ellipse.
  y | Y coordinate of the center of the aa-ellipse.
  rx | Horizontal radius in pixels of the aa-ellipse.
  ry | Vertical radius in pixels of the aa-ellipse.
  color | The color value of the aa-ellipse to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 1741 of file SDL2_gfxPrimitives.c.

int aaellipseRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Sint16 | rx,
|  | Sint16 | ry,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw anti-aliased ellipse with blending.

Parameters:

  renderer | The renderer to draw on.
  x | X coordinate of the center of the aa-ellipse.
  y | Y coordinate of the center of the aa-ellipse.
  rx | Horizontal radius in pixels of the aa-ellipse.
  ry | Vertical radius in pixels of the aa-ellipse.
  r | The red value of the aa-ellipse to draw.
  g | The green value of the aa-ellipse to draw.
  b | The blue value of the aa-ellipse to draw.
  a | The alpha value of the aa-ellipse to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 1762 of file SDL2_gfxPrimitives.c.

int aalineColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Uint32 | color
| ) |  |

Draw anti-aliased line with alpha blending.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point of the aa-line.
  y1 | Y coordinate of the first point of the aa-line.
  x2 | X coordinate of the second point of the aa-line.
  y2 | Y coordinate of the second point of the aa-line.
  color | The color value of the aa-line to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 1030 of file SDL2_gfxPrimitives.c.

int aalineRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw anti-aliased line with alpha blending.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point of the aa-line.
  y1 | Y coordinate of the first point of the aa-line.
  x2 | X coordinate of the second point of the aa-line.
  y2 | Y coordinate of the second point of the aa-line.
  r | The red value of the aa-line to draw.
  g | The green value of the aa-line to draw.
  b | The blue value of the aa-line to draw.
  a | The alpha value of the aa-line to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 1051 of file SDL2_gfxPrimitives.c.

int aapolygonColor | ( | SDL_Renderer * | renderer,
|  | const Sint16 * | vx,
|  | const Sint16 * | vy,
|  | int | n,
|  | Uint32 | color
| ) |  |

Draw anti-aliased polygon with alpha blending.

Parameters:

  renderer | The renderer to draw on.
  vx | Vertex array containing X coordinates of the points of the aa-polygon.
  vy | Vertex array containing Y coordinates of the points of the aa-polygon.
  n | Number of points in the vertex array. Minimum number is 3.
  color | The color value of the aa-polygon to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 2663 of file SDL2_gfxPrimitives.c.

int aapolygonRGBA | ( | SDL_Renderer * | renderer,
|  | const Sint16 * | vx,
|  | const Sint16 * | vy,
|  | int | n,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw anti-aliased polygon with alpha blending.

Parameters:

  renderer | The renderer to draw on.
  vx | Vertex array containing X coordinates of the points of the aa-polygon.
  vy | Vertex array containing Y coordinates of the points of the aa-polygon.
  n | Number of points in the vertex array. Minimum number is 3.
  r | The red value of the aa-polygon to draw.
  g | The green value of the aa-polygon to draw.
  b | The blue value of the aa-polygon to draw.
  a | The alpha value of the aa-polygon to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 2683 of file SDL2_gfxPrimitives.c.

int aatrigonColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Sint16 | x3,
|  | Sint16 | y3,
|  | Uint32 | color
| ) |  |

Draw anti-aliased trigon (triangle outline) with alpha blending.

Note: Creates vertex array and uses aapolygon routine to render.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point of the aa-trigon.
  y1 | Y coordinate of the first point of the aa-trigon.
  x2 | X coordinate of the second point of the aa-trigon.
  y2 | Y coordinate of the second point of the aa-trigon.
  x3 | X coordinate of the third point of the aa-trigon.
  y3 | Y coordinate of the third point of the aa-trigon.
  color | The color value of the aa-trigon to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 2391 of file SDL2_gfxPrimitives.c.

int aatrigonRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Sint16 | x3,
|  | Sint16 | y3,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw anti-aliased trigon (triangle outline) with alpha blending.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point of the aa-trigon.
  y1 | Y coordinate of the first point of the aa-trigon.
  x2 | X coordinate of the second point of the aa-trigon.
  y2 | Y coordinate of the second point of the aa-trigon.
  x3 | X coordinate of the third point of the aa-trigon.
  y3 | Y coordinate of the third point of the aa-trigon.
  r | The red value of the aa-trigon to draw.
  g | The green value of the aa-trigon to draw.
  b | The blue value of the aa-trigon to draw.
  a | The alpha value of the aa-trigon to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 2423 of file SDL2_gfxPrimitives.c.

int arcColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Sint16 | rad,
|  | Sint16 | start,
|  | Sint16 | end,
|  | Uint32 | color
| ) |  |

Arc with blending.

Parameters:

  renderer | The renderer to draw on.
  x | X coordinate of the center of the arc.
  y | Y coordinate of the center of the arc.
  rad | Radius in pixels of the arc.
  start | Starting radius in degrees of the arc. 0 degrees is down, increasing counterclockwise.
  end | Ending radius in degrees of the arc. 0 degrees is down, increasing counterclockwise.
  color | The color value of the arc to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 1109 of file SDL2_gfxPrimitives.c.

int arcRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Sint16 | rad,
|  | Sint16 | start,
|  | Sint16 | end,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Arc with blending.

Parameters:

  renderer | The renderer to draw on.
  x | X coordinate of the center of the arc.
  y | Y coordinate of the center of the arc.
  rad | Radius in pixels of the arc.
  start | Starting radius in degrees of the arc. 0 degrees is down, increasing counterclockwise.
  end | Ending radius in degrees of the arc. 0 degrees is down, increasing counterclockwise.
  r | The red value of the arc to draw.
  g | The green value of the arc to draw.
  b | The blue value of the arc to draw.
  a | The alpha value of the arc to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 1131 of file SDL2_gfxPrimitives.c.

int bezierColor | ( | SDL_Renderer * | renderer,
|  | const Sint16 * | vx,
|  | const Sint16 * | vy,
|  | int | n,
|  | int | s,
|  | Uint32 | color
| ) |  |

Draw a bezier curve with alpha blending.

Parameters:

  renderer | The renderer to draw on.
  vx | Vertex array containing X coordinates of the points of the bezier curve.
  vy | Vertex array containing Y coordinates of the points of the bezier curve.
  n | Number of points in the vertex array. Minimum number is 3.
  s | Number of steps for the interpolation. Minimum number is 2.
  color | The color value of the bezier curve to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 3667 of file SDL2_gfxPrimitives.c.

int bezierRGBA | ( | SDL_Renderer * | renderer,
|  | const Sint16 * | vx,
|  | const Sint16 * | vy,
|  | int | n,
|  | int | s,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw a bezier curve with alpha blending.

Parameters:

  renderer | The renderer to draw on.
  vx | Vertex array containing X coordinates of the points of the bezier curve.
  vy | Vertex array containing Y coordinates of the points of the bezier curve.
  n | Number of points in the vertex array. Minimum number is 3.
  s | Number of steps for the interpolation. Minimum number is 2.
  r | The red value of the bezier curve to draw.
  g | The green value of the bezier curve to draw.
  b | The blue value of the bezier curve to draw.
  a | The alpha value of the bezier curve to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 3688 of file SDL2_gfxPrimitives.c.

int boxColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Uint32 | color
| ) |  |

Draw box (filled rectangle) with blending.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point (i.e. top right) of the box.
  y1 | Y coordinate of the first point (i.e. top right) of the box.
  x2 | X coordinate of the second point (i.e. bottom left) of the box.
  y2 | Y coordinate of the second point (i.e. bottom left) of the box.
  color | The color value of the box to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 644 of file SDL2_gfxPrimitives.c.

int boxRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw box (filled rectangle) with blending.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point (i.e. top right) of the box.
  y1 | Y coordinate of the first point (i.e. top right) of the box.
  x2 | X coordinate of the second point (i.e. bottom left) of the box.
  y2 | Y coordinate of the second point (i.e. bottom left) of the box.
  r | The red value of the box to draw.
  g | The green value of the box to draw.
  b | The blue value of the box to draw.
  a | The alpha value of the box to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 665 of file SDL2_gfxPrimitives.c.

int characterColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | char | c,
|  | Uint32 | color
| ) |  |

Draw a character of the currently set font.

Parameters:

  renderer | The renderer to draw on.
  x | X (horizontal) coordinate of the upper left corner of the character.
  y | Y (vertical) coordinate of the upper left corner of the character.
  c | The character to draw.
  color | The color value of the character to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 3526 of file SDL2_gfxPrimitives.c.

int characterRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | char | c,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw a character of the currently set font.

Parameters:

  renderer | The Renderer to draw on.
  x | X (horizontal) coordinate of the upper left corner of the character.
  y | Y (vertical) coordinate of the upper left corner of the character.
  c | The character to draw.
  r | The red value of the character to draw.
  g | The green value of the character to draw.
  b | The blue value of the character to draw.
  a | The alpha value of the character to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 3404 of file SDL2_gfxPrimitives.c.

int circleColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Sint16 | rad,
|  | Uint32 | color
| ) |  |

Draw circle with blending.

Parameters:

  renderer | The renderer to draw on.
  x | X coordinate of the center of the circle.
  y | Y coordinate of the center of the circle.
  rad | Radius in pixels of the circle.
  color | The color value of the circle to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 1069 of file SDL2_gfxPrimitives.c.

int circleRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Sint16 | rad,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw circle with blending.

Parameters:

  renderer | The renderer to draw on.
  x | X coordinate of the center of the circle.
  y | Y coordinate of the center of the circle.
  rad | Radius in pixels of the circle.
  r | The red value of the circle to draw.
  g | The green value of the circle to draw.
  b | The blue value of the circle to draw.
  a | The alpha value of the circle to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 1089 of file SDL2_gfxPrimitives.c.

int ellipseColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Sint16 | rx,
|  | Sint16 | ry,
|  | Uint32 | color
| ) |  |

Draw ellipse with blending.

Parameters:

  renderer | The renderer to draw on.
  x | X coordinate of the center of the ellipse.
  y | Y coordinate of the center of the ellipse.
  rx | Horizontal radius in pixels of the ellipse.
  ry | Vertical radius in pixels of the ellipse.
  color | The color value of the ellipse to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 1525 of file SDL2_gfxPrimitives.c.

int ellipseRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Sint16 | rx,
|  | Sint16 | ry,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw ellipse with blending.

Parameters:

  renderer | The renderer to draw on.
  x | X coordinate of the center of the ellipse.
  y | Y coordinate of the center of the ellipse.
  rx | Horizontal radius in pixels of the ellipse.
  ry | Vertical radius in pixels of the ellipse.
  r | The red value of the ellipse to draw.
  g | The green value of the ellipse to draw.
  b | The blue value of the ellipse to draw.
  a | The alpha value of the ellipse to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 1546 of file SDL2_gfxPrimitives.c.

int filledCircleColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Sint16 | rad,
|  | Uint32 | color
| ) |  |

Draw filled circle with blending.

Parameters:

  renderer | The renderer to draw on.
  x | X coordinate of the center of the filled circle.
  y | Y coordinate of the center of the filled circle.
  rad | Radius in pixels of the filled circle.
  color | The color value of the filled circle to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 1405 of file SDL2_gfxPrimitives.c.

int filledCircleRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Sint16 | rad,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw filled circle with blending.

Parameters:

  renderer | The renderer to draw on.
  x | X coordinate of the center of the filled circle.
  y | Y coordinate of the center of the filled circle.
  rad | Radius in pixels of the filled circle.
  r | The red value of the filled circle to draw.
  g | The green value of the filled circle to draw.
  b | The blue value of the filled circle to draw.
  a | The alpha value of the filled circle to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 1425 of file SDL2_gfxPrimitives.c.

int filledEllipseColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Sint16 | rx,
|  | Sint16 | ry,
|  | Uint32 | color
| ) |  |

Draw filled ellipse with blending.

Parameters:

  renderer | The renderer to draw on.
  x | X coordinate of the center of the filled ellipse.
  y | Y coordinate of the center of the filled ellipse.
  rx | Horizontal radius in pixels of the filled ellipse.
  ry | Vertical radius in pixels of the filled ellipse.
  color | The color value of the filled ellipse to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 1955 of file SDL2_gfxPrimitives.c.

int filledEllipseRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Sint16 | rx,
|  | Sint16 | ry,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw filled ellipse with blending.

Parameters:

  renderer | The renderer to draw on.
  x | X coordinate of the center of the filled ellipse.
  y | Y coordinate of the center of the filled ellipse.
  rx | Horizontal radius in pixels of the filled ellipse.
  ry | Vertical radius in pixels of the filled ellipse.
  r | The red value of the filled ellipse to draw.
  g | The green value of the filled ellipse to draw.
  b | The blue value of the filled ellipse to draw.
  a | The alpha value of the filled ellipse to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 1976 of file SDL2_gfxPrimitives.c.

int filledPieColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Sint16 | rad,
|  | Sint16 | start,
|  | Sint16 | end,
|  | Uint32 | color
| ) |  |

Draw filled pie with alpha blending.

Parameters:

  renderer | The renderer to draw on.
  x | X coordinate of the center of the filled pie.
  y | Y coordinate of the center of the filled pie.
  rad | Radius in pixels of the filled pie.
  start | Starting radius in degrees of the filled pie.
  end | Ending radius in degrees of the filled pie.
  color | The color value of the filled pie to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 2279 of file SDL2_gfxPrimitives.c.

int filledPieRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Sint16 | rad,
|  | Sint16 | start,
|  | Sint16 | end,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw filled pie with alpha blending.

Parameters:

  renderer | The renderer to draw on.
  x | X coordinate of the center of the filled pie.
  y | Y coordinate of the center of the filled pie.
  rad | Radius in pixels of the filled pie.
  start | Starting radius in degrees of the filled pie.
  end | Ending radius in degrees of the filled pie.
  r | The red value of the filled pie to draw.
  g | The green value of the filled pie to draw.
  b | The blue value of the filled pie to draw.
  a | The alpha value of the filled pie to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 2301 of file SDL2_gfxPrimitives.c.

int filledPolygonColor | ( | SDL_Renderer * | renderer,
|  | const Sint16 * | vx,
|  | const Sint16 * | vy,
|  | int | n,
|  | Uint32 | color
| ) |  |

Draw filled polygon with alpha blending.

Parameters:

  renderer | The renderer to draw on.
  vx | Vertex array containing X coordinates of the points of the filled polygon.
  vy | Vertex array containing Y coordinates of the points of the filled polygon.
  n | Number of points in the vertex array. Minimum number is 3.
  color | The color value of the filled polygon to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 2946 of file SDL2_gfxPrimitives.c.

int filledPolygonRGBA | ( | SDL_Renderer * | renderer,
|  | const Sint16 * | vx,
|  | const Sint16 * | vy,
|  | int | n,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw filled polygon with alpha blending.

Parameters:

  renderer | The renderer to draw on.
  vx | Vertex array containing X coordinates of the points of the filled polygon.
  vy | Vertex array containing Y coordinates of the points of the filled polygon.
  n | Number of points in the vertex array. Minimum number is 3.
  r | The red value of the filled polygon to draw.
  g | The green value of the filled polygon to draw.
  b | The blue value of the filed polygon to draw.
  a | The alpha value of the filled polygon to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 2966 of file SDL2_gfxPrimitives.c.

int filledPolygonRGBAMT | ( | SDL_Renderer * | renderer,
|  | const Sint16 * | vx,
|  | const Sint16 * | vy,
|  | int | n,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a,
|  | int ** | polyInts,
|  | int * | polyAllocated
| ) |  |

Draw filled polygon with alpha blending (multi-threaded capable).

Note: The last two parameters are optional; but are required for multithreaded operation.

Parameters:

  renderer | The renderer to draw on.
  vx | Vertex array containing X coordinates of the points of the filled polygon.
  vy | Vertex array containing Y coordinates of the points of the filled polygon.
  n | Number of points in the vertex array. Minimum number is 3.
  r | The red value of the filled polygon to draw.
  g | The green value of the filled polygon to draw.
  b | The blue value of the filled polygon to draw.
  a | The alpha value of the filled polygon to draw.
  polyInts | Preallocated, temporary vertex array used for sorting vertices. Required for multithreaded operation; set to NULL otherwise.
  polyAllocated | Flag indicating if temporary vertex array was allocated. Required for multithreaded operation; set to NULL otherwise.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 2778 of file SDL2_gfxPrimitives.c.

int filledTrigonColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Sint16 | x3,
|  | Sint16 | y3,
|  | Uint32 | color
| ) |  |

Draw filled trigon (triangle) with alpha blending.

Note: Creates vertex array and uses aapolygon routine to render.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point of the filled trigon.
  y1 | Y coordinate of the first point of the filled trigon.
  x2 | X coordinate of the second point of the filled trigon.
  y2 | Y coordinate of the second point of the filled trigon.
  x3 | X coordinate of the third point of the filled trigon.
  y3 | Y coordinate of the third point of the filled trigon.
  color | The color value of the filled trigon to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 2457 of file SDL2_gfxPrimitives.c.

int filledTrigonRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Sint16 | x3,
|  | Sint16 | y3,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw filled trigon (triangle) with alpha blending.

Note: Creates vertex array and uses aapolygon routine to render.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point of the filled trigon.
  y1 | Y coordinate of the first point of the filled trigon.
  x2 | X coordinate of the second point of the filled trigon.
  y2 | Y coordinate of the second point of the filled trigon.
  x3 | X coordinate of the third point of the filled trigon.
  y3 | Y coordinate of the third point of the filled trigon.
  r | The red value of the filled trigon to draw.
  g | The green value of the filled trigon to draw.
  b | The blue value of the filled trigon to draw.
  a | The alpha value of the filled trigon to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 2491 of file SDL2_gfxPrimitives.c.

void gfxPrimitivesSetFont | ( | const void * | fontdata,
|  | Uint32 | cw,
|  | Uint32 | ch
| ) |  |

Sets or resets the current global font data.

The font data array is organized in follows: [fontdata] = [character 0][character 1]...[character 255] where [character n] = [byte 1 row 1][byte 2 row 1]...[byte {pitch} row 1][byte 1 row 2] ...[byte {pitch} row height] where [byte n] = [bit 0]...[bit 7] where [bit n] = [0 for transparent pixel|1 for colored pixel]

Parameters:

  fontdata | Pointer to array of font data. Set to NULL, to reset global font to the default 8x8 font.
  cw | Width of character in bytes. Ignored if fontdata==NULL.
  ch | Height of character in bytes. Ignored if fontdata==NULL.

Definition at line 3312 of file SDL2_gfxPrimitives.c.

void gfxPrimitivesSetFontRotation | ( | Uint32 | rotation | ) |

Sets current global font character rotation steps.

Default is 0 (no rotation). 1 = 90deg clockwise. 2 = 180deg clockwise. 3 = 270deg clockwise. Changing the rotation, will reset the character cache.

Parameters:

  rotation | Number of 90deg clockwise steps to rotate

Definition at line 3358 of file SDL2_gfxPrimitives.c.

int hline | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | x2,
|  | Sint16 | y
| ) |  |

Draw horizontal line in currently set color.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point (i.e. left) of the line.
  x2 | X coordinate of the second point (i.e. right) of the line.
  y | Y coordinate of the points of the line.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 158 of file SDL2_gfxPrimitives.c.

int hlineColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | x2,
|  | Sint16 | y,
|  | Uint32 | color
| ) |  |

Draw horizontal line with blending.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point (i.e. left) of the line.
  x2 | X coordinate of the second point (i.e. right) of the line.
  y | Y coordinate of the points of the line.
  color | The color value of the line to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 175 of file SDL2_gfxPrimitives.c.

int hlineRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | x2,
|  | Sint16 | y,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw horizontal line with blending.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point (i.e. left) of the line.
  x2 | X coordinate of the second point (i.e. right) of the line.
  y | Y coordinate of the points of the line.
  r | The red value of the line to draw.
  g | The green value of the line to draw.
  b | The blue value of the line to draw.
  a | The alpha value of the line to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 195 of file SDL2_gfxPrimitives.c.

int line | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2
| ) |  |

Draw line with alpha blending using the currently set color.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point of the line.
  y1 | Y coordinate of the first point of the line.
  x2 | X coordinate of the second point of the line.
  y2 | Y coordinate of the second point of the line.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 735 of file SDL2_gfxPrimitives.c.

int lineColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Uint32 | color
| ) |  |

Draw line with alpha blending.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point of the line.
  y1 | Y coordinate of the first point of the line.
  x2 | X coordinate of the second point of the line.
  y2 | Y coordinate of the seond point of the line.
  color | The color value of the line to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 755 of file SDL2_gfxPrimitives.c.

int lineRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw line with alpha blending.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point of the line.
  y1 | Y coordinate of the first point of the line.
  x2 | X coordinate of the second point of the line.
  y2 | Y coordinate of the second point of the line.
  r | The red value of the line to draw.
  g | The green value of the line to draw.
  b | The blue value of the line to draw.
  a | The alpha value of the line to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 776 of file SDL2_gfxPrimitives.c.

int pieColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Sint16 | rad,
|  | Sint16 | start,
|  | Sint16 | end,
|  | Uint32 | color
| ) |  |

Draw pie (outline) with alpha blending.

Parameters:

  renderer | The renderer to draw on.
  x | X coordinate of the center of the pie.
  y | Y coordinate of the center of the pie.
  rad | Radius in pixels of the pie.
  start | Starting radius in degrees of the pie.
  end | Ending radius in degrees of the pie.
  color | The color value of the pie to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 2237 of file SDL2_gfxPrimitives.c.

int pieRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Sint16 | rad,
|  | Sint16 | start,
|  | Sint16 | end,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw pie (outline) with alpha blending.

Parameters:

  renderer | The renderer to draw on.
  x | X coordinate of the center of the pie.
  y | Y coordinate of the center of the pie.
  rad | Radius in pixels of the pie.
  start | Starting radius in degrees of the pie.
  end | Ending radius in degrees of the pie.
  r | The red value of the pie to draw.
  g | The green value of the pie to draw.
  b | The blue value of the pie to draw.
  a | The alpha value of the pie to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 2260 of file SDL2_gfxPrimitives.c.

int pixel | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y
| ) |  |

Draw pixel in currently set color.

Parameters:

  renderer | The renderer to draw on.
  x | X (horizontal) coordinate of the pixel.
  y | Y (vertical) coordinate of the pixel.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 73 of file SDL2_gfxPrimitives.c.

int pixelColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Uint32 | color
| ) |  |

Draw pixel with blending enabled if a<255.

Parameters:

  renderer | The renderer to draw on.
  x | X (horizontal) coordinate of the pixel.
  y | Y (vertical) coordinate of the pixel.
  color | The color value of the pixel to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 88 of file SDL2_gfxPrimitives.c.

int pixelRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw pixel with blending enabled if a<255.

Parameters:

  renderer | The renderer to draw on.
  x | X (horizontal) coordinate of the pixel.
  y | Y (vertical) coordinate of the pixel.
  r | The red color value of the pixel to draw.
  g | The green color value of the pixel to draw.
  b | The blue color value of the pixel to draw.
  a | The alpha value of the pixel to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 107 of file SDL2_gfxPrimitives.c.

int pixelRGBAWeight | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a,
|  | Uint32 | weight
| ) |  |

Draw pixel with blending enabled and using alpha weight on color.

Parameters:

  renderer | The renderer to draw on.
  x | The horizontal coordinate of the pixel.
  y | The vertical position of the pixel.
  r | The red color value of the pixel to draw.
  g | The green color value of the pixel to draw.
  b | The blue color value of the pixel to draw.
  a | The alpha value of the pixel to draw.
  weight | The weight multiplied into the alpha value of the pixel.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 130 of file SDL2_gfxPrimitives.c.

int polygon | ( | SDL_Renderer * | renderer,
|  | const Sint16 * | vx,
|  | const Sint16 * | vy,
|  | int | n
| ) |  |

Draw polygon with the currently set color and blend mode.

Parameters:

  renderer | The renderer to draw on.
  vx | Vertex array containing X coordinates of the points of the polygon.
  vy | Vertex array containing Y coordinates of the points of the polygon.
  n | Number of points in the vertex array. Minimum number is 3.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 2536 of file SDL2_gfxPrimitives.c.

int polygonColor | ( | SDL_Renderer * | renderer,
|  | const Sint16 * | vx,
|  | const Sint16 * | vy,
|  | int | n,
|  | Uint32 | color
| ) |  |

Draw polygon with alpha blending.

Parameters:

  renderer | The renderer to draw on.
  vx | Vertex array containing X coordinates of the points of the polygon.
  vy | Vertex array containing Y coordinates of the points of the polygon.
  n | Number of points in the vertex array. Minimum number is 3.
  color | The color value of the polygon to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 2520 of file SDL2_gfxPrimitives.c.

int polygonRGBA | ( | SDL_Renderer * | renderer,
|  | const Sint16 * | vx,
|  | const Sint16 * | vy,
|  | int | n,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw polygon with alpha blending.

Parameters:

  renderer | The renderer to draw on.
  vx | Vertex array containing X coordinates of the points of the polygon.
  vy | Vertex array containing Y coordinates of the points of the polygon.
  n | Number of points in the vertex array. Minimum number is 3.
  r | The red value of the polygon to draw.
  g | The green value of the polygon to draw.
  b | The blue value of the polygon to draw.
  a | The alpha value of the polygon to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 2602 of file SDL2_gfxPrimitives.c.

int rectangleColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Uint32 | color
| ) |  |

Draw rectangle with blending.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point (i.e. top right) of the rectangle.
  y1 | Y coordinate of the first point (i.e. top right) of the rectangle.
  x2 | X coordinate of the second point (i.e. bottom left) of the rectangle.
  y2 | Y coordinate of the second point (i.e. bottom left) of the rectangle.
  color | The color value of the rectangle to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 260 of file SDL2_gfxPrimitives.c.

int rectangleRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw rectangle with blending.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point (i.e. top right) of the rectangle.
  y1 | Y coordinate of the first point (i.e. top right) of the rectangle.
  x2 | X coordinate of the second point (i.e. bottom left) of the rectangle.
  y2 | Y coordinate of the second point (i.e. bottom left) of the rectangle.
  r | The red value of the rectangle to draw.
  g | The green value of the rectangle to draw.
  b | The blue value of the rectangle to draw.
  a | The alpha value of the rectangle to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 281 of file SDL2_gfxPrimitives.c.

int roundedBoxColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Sint16 | rad,
|  | Uint32 | color
| ) |  |

Draw rounded-corner box (filled rectangle) with blending.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point (i.e. top right) of the box.
  y1 | Y coordinate of the first point (i.e. top right) of the box.
  x2 | X coordinate of the second point (i.e. bottom left) of the box.
  y2 | Y coordinate of the second point (i.e. bottom left) of the box.
  rad | The radius of the corner arcs of the box.
  color | The color value of the box to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 498 of file SDL2_gfxPrimitives.c.

int roundedBoxRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Sint16 | rad,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw rounded-corner box (filled rectangle) with blending.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point (i.e. top right) of the box.
  y1 | Y coordinate of the first point (i.e. top right) of the box.
  x2 | X coordinate of the second point (i.e. bottom left) of the box.
  y2 | Y coordinate of the second point (i.e. bottom left) of the box.
  rad | The radius of the corner arcs of the box.
  r | The red value of the box to draw.
  g | The green value of the box to draw.
  b | The blue value of the box to draw.
  a | The alpha value of the box to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 520 of file SDL2_gfxPrimitives.c.

int roundedRectangleColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Sint16 | rad,
|  | Uint32 | color
| ) |  |

Draw rounded-corner rectangle with blending.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point (i.e. top right) of the rectangle.
  y1 | Y coordinate of the first point (i.e. top right) of the rectangle.
  x2 | X coordinate of the second point (i.e. bottom left) of the rectangle.
  y2 | Y coordinate of the second point (i.e. bottom left) of the rectangle.
  rad | The radius of the corner arc.
  color | The color value of the rectangle to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 353 of file SDL2_gfxPrimitives.c.

int roundedRectangleRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Sint16 | rad,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw rounded-corner rectangle with blending.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point (i.e. top right) of the rectangle.
  y1 | Y coordinate of the first point (i.e. top right) of the rectangle.
  x2 | X coordinate of the second point (i.e. bottom left) of the rectangle.
  y2 | Y coordinate of the second point (i.e. bottom left) of the rectangle.
  rad | The radius of the corner arc.
  r | The red value of the rectangle to draw.
  g | The green value of the rectangle to draw.
  b | The blue value of the rectangle to draw.
  a | The alpha value of the rectangle to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 375 of file SDL2_gfxPrimitives.c.

int stringColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | const char * | s,
|  | Uint32 | color
| ) |  |

Draw a string in the currently set font.

The spacing between consequtive characters in the string is the fixed number of pixels of the character width of the current global font.

Parameters:

  renderer | The renderer to draw on.
  x | X (horizontal) coordinate of the upper left corner of the string.
  y | Y (vertical) coordinate of the upper left corner of the string.
  s | The string to draw.
  color | The color value of the string to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 3547 of file SDL2_gfxPrimitives.c.

int stringRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y,
|  | const char * | s,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw a string in the currently set font.

Parameters:

  renderer | The renderer to draw on.
  x | X (horizontal) coordinate of the upper left corner of the string.
  y | Y (vertical) coordinate of the upper left corner of the string.
  s | The string to draw.
  r | The red value of the string to draw.
  g | The green value of the string to draw.
  b | The blue value of the string to draw.
  a | The alpha value of the string to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 3567 of file SDL2_gfxPrimitives.c.

int texturedPolygon | ( | SDL_Renderer * | renderer,
|  | const Sint16 * | vx,
|  | const Sint16 * | vy,
|  | int | n,
|  | SDL_Surface * | texture,
|  | int | texture_dx,
|  | int | texture_dy
| ) |  |

Draws a polygon filled with the given texture.

This standard version is calling multithreaded versions with NULL cache parameters.

Parameters:

  renderer | The renderer to draw on.
  vx | array of x vector components
  vy | array of x vector components
  n | the amount of vectors in the vx and vy array
  texture | the sdl surface to use to fill the polygon
  texture_dx | the offset of the texture relative to the screeen. if you move the polygon 10 pixels to the left and want the texture to apear the same you need to increase the texture_dx value
  texture_dy | see texture_dx

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 3244 of file SDL2_gfxPrimitives.c.

int texturedPolygonMT | ( | SDL_Renderer * | renderer,
|  | const Sint16 * | vx,
|  | const Sint16 * | vy,
|  | int | n,
|  | SDL_Surface * | texture,
|  | int | texture_dx,
|  | int | texture_dy,
|  | int ** | polyInts,
|  | int * | polyAllocated
| ) |  |

Draws a polygon filled with the given texture (Multi-Threading Capable).

Parameters:

  renderer | The renderer to draw on.
  vx | array of x vector components
  vy | array of x vector components
  n | the amount of vectors in the vx and vy array
  texture | the sdl surface to use to fill the polygon
  texture_dx | the offset of the texture relative to the screeen. If you move the polygon 10 pixels to the left and want the texture to apear the same you need to increase the texture_dx value
  texture_dy | see texture_dx
  polyInts | Preallocated temp array storage for vertex sorting (used for multi-threaded operation)
  polyAllocated | Flag indicating oif the temp array was allocated (used for multi-threaded operation)

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 3082 of file SDL2_gfxPrimitives.c.

int thickLineColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Uint8 | width,
|  | Uint32 | color
| ) |  |

Draw a thick line with alpha blending.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point of the line.
  y1 | Y coordinate of the first point of the line.
  x2 | X coordinate of the second point of the line.
  y2 | Y coordinate of the second point of the line.
  width | Width of the line in pixels. Must be >0.
  color | The color value of the line to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 4239 of file SDL2_gfxPrimitives.c.

int thickLineRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Uint8 | width,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw a thick line with alpha blending.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point of the line.
  y1 | Y coordinate of the first point of the line.
  x2 | X coordinate of the second point of the line.
  y2 | Y coordinate of the second point of the line.
  width | Width of the line in pixels. Must be >0.
  r | The red value of the character to draw.
  g | The green value of the character to draw.
  b | The blue value of the character to draw.
  a | The alpha value of the character to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 4261 of file SDL2_gfxPrimitives.c.

int trigonColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Sint16 | x3,
|  | Sint16 | y3,
|  | Uint32 | color
| ) |  |

Draw trigon (triangle outline) with alpha blending.

Note: Creates vertex array and uses polygon routine to render.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point of the trigon.
  y1 | Y coordinate of the first point of the trigon.
  x2 | X coordinate of the second point of the trigon.
  y2 | Y coordinate of the second point of the trigon.
  x3 | X coordinate of the third point of the trigon.
  y3 | Y coordinate of the third point of the trigon.
  color | The color value of the trigon to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 2325 of file SDL2_gfxPrimitives.c.

int trigonRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x1,
|  | Sint16 | y1,
|  | Sint16 | x2,
|  | Sint16 | y2,
|  | Sint16 | x3,
|  | Sint16 | y3,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw trigon (triangle outline) with alpha blending.

Parameters:

  renderer | The renderer to draw on.
  x1 | X coordinate of the first point of the trigon.
  y1 | Y coordinate of the first point of the trigon.
  x2 | X coordinate of the second point of the trigon.
  y2 | Y coordinate of the second point of the trigon.
  x3 | X coordinate of the third point of the trigon.
  y3 | Y coordinate of the third point of the trigon.
  r | The red value of the trigon to draw.
  g | The green value of the trigon to draw.
  b | The blue value of the trigon to draw.
  a | The alpha value of the trigon to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 2357 of file SDL2_gfxPrimitives.c.

int vlineColor | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y1,
|  | Sint16 | y2,
|  | Uint32 | color
| ) |  |

Draw vertical line with blending.

Parameters:

  renderer | The renderer to draw on.
  x | X coordinate of the points of the line.
  y1 | Y coordinate of the first point (i.e. top) of the line.
  y2 | Y coordinate of the second point (i.e. bottom) of the line.
  color | The color value of the line to draw (0xRRGGBBAA).

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 217 of file SDL2_gfxPrimitives.c.

int vlineRGBA | ( | SDL_Renderer * | renderer,
|  | Sint16 | x,
|  | Sint16 | y1,
|  | Sint16 | y2,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b,
|  | Uint8 | a
| ) |  |

Draw vertical line with blending.

Parameters:

  renderer | The renderer to draw on.
  x | X coordinate of the points of the line.
  y1 | Y coordinate of the first point (i.e. top) of the line.
  y2 | Y coordinate of the second point (i.e. bottom) of the line.
  r | The red value of the line to draw.
  g | The green value of the line to draw.
  b | The blue value of the line to draw.
  a | The alpha value of the line to draw.

Returns:
  Returns 0 on success, -1 on failure.

Definition at line 237 of file SDL2_gfxPrimitives.c.